package sample02;

public class ImmutableMain {

    public static void main(String[] args) {
        Counter counter = new Counter(0);

        System.out.println(counter.getValue());

        Counter newCounter = counter.countUp();

        //元のCounterインスタンスは0のまま
        System.out.println(counter.getValue());

        //新しいCounterインスタンスは1
        System.out.println(newCounter.getValue());
    }

    public static class Counter {

        private final int value;

        public Counter(int value) {
            this.value = value;
        }

        public Counter countUp() {
            return new Counter(value + 1);
        }

        public int getValue() {
            return value;
        }
    }
}
