package sample04;

import java.util.Optional;

public class OptionalOrSample {

    public static void main(String[] args) {
        new OptionalOrSample().run();
    }

    public void run() {

        //foo()またはbar()

        Optional<String> fooOrBar1 = foo().map(Optional::of).orElseGet(this::bar);

        Optional<String> fooOrBar2 = foo();
        if (fooOrBar2.isPresent() == false) {
            fooOrBar2 = bar();
        }

        System.out.println(fooOrBar1);
        System.out.println(fooOrBar2);
    }

    Optional<String> foo() {
        return Optional.empty();
    }

    Optional<String> bar() {
        return Optional.of("bar");
    }

}
