package sample07;

import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ExtractMethodSample2 {

    public static void main(String[] args) {
        Stream<String> stream = Stream.of("a", "b", "c");
        int n = 3;
        List<String> ret = stream.map(s -> times(n, s))
                .collect(Collectors.toList());
        System.out.println(ret); //[aaa, bbb, ccc]
    }

    static String times(int n, String s) {
        return String.join("", Collections.nCopies(n, s));
    }
}
