# Optional/Streamのサンプルコード

「Optional/Stream適材適所 ──関数プログラミング的な書き方をするとき／しないとき」のサンプルコードです。

## Eclipseへのインポート

次のコマンドを実行してからインポートしてください。

```
./gradlew eclipse
```

Windowsの場合は次のコマンドになります。

```
gradlew.bat eclipse
```

## サンプルコードのファイル構成

```
LICENSE                 このサンプルコードのライセンスです
README.md               このファイルです
build.gradle            Gradleのビルドスクリプトです
eclipse.gradle          GradleでEclipseインポートに必要なファイルを作成するための設定ファイルです
gradle                  Gradleが使用するファイルが格納されています
gradlew                 Gradleの起動スクリプトです
gradlew.bat             Gradleの起動スクリプトです(Windows用)
settings.gradle         Gradleが使用するプロジェクトの設定ファイルです
src
└── main
    └── java
        ├── sample01    Optionalの例が格納されています
        ├── sample02    副作用の有無の例が格納されています
        ├── sample03    高階メソッドの例が格納されています
        ├── sample04    複数のOptionalを使う例、Optionalをorでつなぐ例が格納されています
        ├── sample05    ラムダ式とチェック例外の例が格納されています
        ├── sample06    CollectorとIteratorの例が格納されています
        ├── sample07    高階メソッドへの切り出し方の例が格納されています
        ├── sample08    関数合成の例が格納されています
        └── sample09    副作用の局所化の例が格納されています


```

## ライセンス

このサンプルコード一式は[The MIT License](https://opensource.org/licenses/MIT)のもとに提供します。

## 作者

のざき、うらがみ
