package sample03;

import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class ComparatorSample {

    public static void main(String[] args) {

        List<String> list = Arrays.asList("12345", "1", "1234", "12", "123");

        //関数インタフェースなのでラムダ式でインスタンスを得られる
        Comparator<String> c = (s1, s2) -> s1.length() - s2.length();

        //関数インタフェースを渡しているので高階メソッドと言える
        Collections.sort(list, c);

        System.out.println(list); //[1, 12, 123, 1234, 12345]
    }
}
