package sample07;

import java.util.Collections;
import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ExtractMethodSample3 {

    public static void main(String[] args) {
        Stream<String> stream = Stream.of("a", "b", "c");
        int n = 3;
        List<String> ret = stream.map(times(n))
                .collect(Collectors.toList());
        System.out.println(ret); //[aaa, bbb, ccc]
    }

    static Function<String, String> times(int n) {
        return s -> String.join("", Collections.nCopies(n, s));
    }
}
