package sample08;

import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import sample08.model.Bar;
import sample08.model.Baz;
import sample08.model.Foo;
import sample08.model.Hoge;

public class ComposeSample2 {

    public static void main(String[] args) {

        int n = 3;
        Stream<Hoge> stream = Stream.of(new Hoge("aaa"), new Hoge("bbb"), new Hoge("ccc"));
        List<Baz> ret = stream.map(a -> Foo.fromHoge(a))
                .map(toBar(n))
                .map(Bar::getBaz)
                .collect(Collectors.toList());

        System.out.println(ret); //[3:aaa, 3:bbb, 3:ccc]
    }

    static Function<Foo, Bar> toBar(int n) {
        return f -> new Bar(n, f);
    }
}
